package net.wicp.tams.app.duckula.controller.config.constant;

import net.wicp.tams.common.constant.dic.intf.IEnumCombobox;

/**
 * checkpoint的实现方式
 * 
 * @author andy.zhou
 *
 */
public enum DevOpsType implements IEnumCombobox {

	flink("flink流计算", "oss://lc-bigdata/doris/check_system.sh", "oss://lc-bigdata/doris/%s/check_system.sh", "v12"),

	doris("大数据存储", "oss://lc-bigdata/doris/check_system.sh", "", ""),

	dmep("dmep数据平台", "", "", "");

	private final String desc;
	private final String checkurl;
	private final String installurlFormat;
	private final String lastversion;

	public String getCheckurl() {
		return checkurl;
	}

	public String getLastversion() {
		return lastversion;
	}

	public String getInstallurl() {
		return String.format(this.installurlFormat, lastversion);
	}

	private DevOpsType(String desc, String checkurl, String installurlFormat, String lastversion) {
		this.desc = desc;
		this.checkurl = checkurl;
		this.installurlFormat = installurlFormat;
		this.lastversion = lastversion;
	}

	public String getDesc() {
		return desc;
	}

	public String getName() {
		return this.name();
	}

	@Override
	public String getDesc_zh() {
		return this.desc;
	}

	@Override
	public String getDesc_en() {
		return this.name();
	}
}
