package net.wicp.tams.duckula.ops.pages.devops;

import org.apache.tapestry5.ioc.annotations.Inject;
import org.apache.tapestry5.util.TextStreamResponse;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

import lombok.extern.slf4j.Slf4j;
import net.wicp.tams.app.duckula.controller.bean.models.DevopsFlink;
import net.wicp.tams.app.duckula.controller.config.constant.DevOpsType;
import net.wicp.tams.app.duckula.controller.dao.DevopsFlinkMapper;
import net.wicp.tams.common.Result;
import net.wicp.tams.common.apiext.StringUtil;
import net.wicp.tams.common.constant.PathType;
import net.wicp.tams.common.os.SSHAssit;
import net.wicp.tams.common.os.pool.SSHConnection;
import net.wicp.tams.component.tools.TapestryAssist;
import net.wicp.tams.duckula.ops.pages.ParentPageBean;

@Slf4j
public class FlinkConfig extends ParentPageBean<DevopsFlink> {

	@Inject
	private DevopsFlinkMapper devopsFlinkMapper;

	@Override
	public void doSave(DevopsFlink t, boolean isInsert) {
		if (isInsert) {
			devopsFlinkMapper.insert(t);
		} else {
			devopsFlinkMapper.updateByPrimaryKeySelective(t);
		}
	}

	@Override
	public void doDel(String id) {
		this.devopsFlinkMapper.deleteById(id);
	}

	@Override
	public BaseMapper<DevopsFlink> getBaseMapper() {
		return this.devopsFlinkMapper;
	}

	@Override
	public void packageQuery(DevopsFlink t, QueryWrapper<DevopsFlink> queryWrapper) {
		if (StringUtil.isNotNull(t.getName())) {
			queryWrapper.eq("name", t.getName());
		}
		if (StringUtil.isNotNull(t.getIsInit())) {
			queryWrapper.eq("is_init", t.getIsInit());
		}
	}

	/***
	 * 测试用后端调用
	 * 
	 * @return
	 */
	public TextStreamResponse onCheckHost() {
		final DevopsFlink devopsFlink = TapestryAssist.getBeanFromPage(DevopsFlink.class, requestGlobals);
		// 1、OSS下载
		String localPath = PathType.getPath(DevOpsType.flink.getCheckurl());
		// 1、登陆
		SSHConnection conn = SSHAssit.getConn(devopsFlink.getIp(), "root", devopsFlink.getRootPwd());
		String fileName = localPath.substring(localPath.lastIndexOf("/") + 1);
		conn.scp(localPath, fileName, "~", "0744");
		// 执行
		Result result = conn.executeCommand(String.format("sh ~/%s", fileName));
		log.info(result.getMessage());
		conn.close();
		return TapestryAssist.getTextStreamResponse(Result.getError("检查结果：" + result.getMessage()));
	}

}
